import sys

EXAMPLE_TIME = 50.0

def readData(fileName,inputLines):
    data = []
    dataFileHandle = open(fileName,'r')
    for lineNumber in range (0,NUMBER_INPUT_LINES):
        inputLine = dataFileHandle.readline()
        dataItemStrings = inputLine.split()
        category = int(dataItemStrings[0])
        feature0 = int(dataItemStrings[1])
        feature1 = int(dataItemStrings[2])
        feature2 = int(dataItemStrings[3])
        feature3 = int(dataItemStrings[4])
        feature4 = int(dataItemStrings[5])
        feature5 = int(dataItemStrings[6])
        dataLine = [category,feature0,feature1,feature2,feature3,feature4,feature5]
        #print dataLine,dataItemStrings[7]
        data = data + [dataLine]

    dataFileHandle.close()
    return data

def readSpikes(fileName):
    spikeFileHandle = open(fileName,'r')
    inputLine = "blank"
    spikes = [[],[]]
    while (len (inputLine) > 0):
        inputLine = spikeFileHandle.readline()
        if (len (inputLine) > 0):
            spikeItemStrings = inputLine.split()
            neuron = int(spikeItemStrings[0])
            time = float(spikeItemStrings[1])
            spikes[neuron] = spikes[neuron]+[time]
    return spikes

def testCategory(spikes,data,numberLines):
    right0 = 0
    right1 = 0
    wrong0 = 0
    wrong1 = 0
    draw = 0
    time = 0
    for line in range (0,numberLines):
    #for line in range (0,2):
        #print 
        #print data[line][0]

        first0Spike = 0
        first1Spike = 0
        category = -1
        for spikeOffset in range (0,len(spikes[0])):
            spike = spikes[0][spikeOffset]
            if (spike > time) and (spike < (time + EXAMPLE_TIME )):
                if (first0Spike == 0):
                    first0Spike = spike
                #print "0 ", spike
        for spikeOffset in range (0,len(spikes[1])):
            spike = spikes[1][spikeOffset]
            if (spike > time) and (spike < (time + EXAMPLE_TIME )):
                if (first1Spike == 0):
                    first1Spike = spike
                #print "1 ", first1Spike

        #if there are no spikes make the time large
        if (first0Spike == 0):
            first0Spike =9999999.9 
        if (first1Spike == 0):
            first1Spike =9999999.9


        if (first0Spike < first1Spike):
            category = 0
            if (category == data[line][0]):
                right0 += 1
            else:
                wrong0 += 1
        elif (first1Spike < first0Spike):
            category = 1
            if (category == data[line][0]):
                right1 += 1
            else:
                wrong1 += 1
        else:
            #draw goes to cat 0
            if (0 == data[line][0]):
                right0 += 1
            else:
                wrong0 += 1
            #draw goes to cat 1
            #if (1 == data[line][0]):
            #    right1 += 1
            #else:
            #    wrong1 += 1
            
            #category = -1
            #draw+=1

        time = time + EXAMPLE_TIME 
        #print right0,right1,draw,wrong0,wrong1, (right0+right1+draw+wrong0+
        #                                         wrong1),data[line]
        #print
    print right0,right1,draw,wrong0,wrong1, (right0+right1+draw+wrong0+wrong1),data[line]
        
def testF5E1Category(spikes,data,numberLines):
    right0 = 0
    right1 = 0
    wrong0 = 0
    wrong1 = 0
    draw = 0
    time = 0
    for line in range (0,numberLines):
    #for line in range (0,2):
        #print 
        #print data[line][0]
        if (data[line][5] == 1):
            first0Spike = 0
            first1Spike = 0
            category = -1
            for spikeOffset in range (0,len(spikes[0])):
                spike = spikes[0][spikeOffset]
                if (spike > time) and (spike < (time + EXAMPLE_TIME )):
                    if (first0Spike == 0):
                        first0Spike = spike
                        #print "0 ", spike
            for spikeOffset in range (0,len(spikes[1])):
                spike = spikes[1][spikeOffset]
                if (spike > time) and (spike < (time + EXAMPLE_TIME )):
                    if (first1Spike == 0):
                        first1Spike = spike
                    #print "1 ", first1Spike

            #if there are no spikes make the time large
            if (first0Spike == 0):
                first0Spike =9999999.9 
            if (first1Spike == 0):
                first1Spike =9999999.9

            if (first0Spike < first1Spike):
                category = 0
                if (category == data[line][0]):
                    right0 += 1
                else:
                    wrong0 += 1
            elif (first1Spike < first0Spike):
                category = 1
                if (category == data[line][0]):
                    right1 += 1
                else:
                    wrong1 += 1
            else:
                category = -1
                draw+=1

        time = time + EXAMPLE_TIME 
        #print right0,right1,draw,wrong0,wrong1, (right0+right1+draw+wrong0+
        #                                         wrong1),data[line]
        #print
        
    print right0,right1,draw,wrong0,wrong1, (right0+right1+draw+wrong0+ wrong1),data[line]
    

##--main---
args = sys.argv
numberArgs = args.__len__()
print args, numberArgs
if (numberArgs == 3):
    testFile = args[1]
    dataFile = args[2]
elif (numberArgs == 2):
    testFile = args[1]
    dataFile = "monkData/monks-1.test"
else:
    testFile = "output/secondTest.sp"
    dataFile = "monkData/monks-1.test"


NUMBER_INPUT_LINES = 124
#data = readData("monkData/monks-1.train",NUMBER_INPUT_LINES)
data = readData("monkData/monks-1.test",NUMBER_INPUT_LINES)
#print data
spikes = readSpikes(testFile)
#print spikes
testCategory(spikes,data,NUMBER_INPUT_LINES)

testF5E1Category(spikes,data,NUMBER_INPUT_LINES)
