import pandas as pd
import numpy as np
import sys
from sklearn import metrics
def get_metrics(y_test,classes):
    print('Accuracy ',metrics.accuracy_score(y_test,classes))
    print('Precision ',metrics.precision_score(y_test,classes,average=None))
    print('Recall ',metrics.recall_score(y_test,classes,average=None))
#y_test = np.load('processed_data/y_test.txt',allow_pickle=True)
args = sys.argv
numberArgs = args.__len__()
if (numberArgs == 2):
    classesFileName = args[1]
    y_testFileName = "processed_data/y_test.npy"
elif (numberArgs == 3):
    classesFileName = args[1]
    y_testFileName = args[2]
else:
    classesFileName = "processed_data/X_predicted.npy"
    y_testFileName = "processed_data/y_test.npy"
classes = np.load(classesFileName,allow_pickle=True)
y_test = np.load(y_testFileName,allow_pickle=True)
get_metrics(y_test,classes)



